indexing

	description: "Field Content-Disposition"

	author: "Berend de Boer"
	date: "$Date: 2003/05/08 $"
	revision: "$Revision: #1 $"


class

	EPX_MIME_FIELD_IF_MODIFIED_SINCE


inherit

	EPX_MIME_FIELD_WITH_PARAMETERS

	EPX_MIME_PARAMETER_NAMES
		export
			{NONE} all
		end


creation

	make


feature -- Initialization

	make (a_date_time: STDC_TIME) is
			-- Initialize If-Modified-Since.
		require
			a_date_time_not_void: a_date_time /= Void
			time_zone_known: a_date_time.is_time_zone_known
		do
			make_parameters
			date_time := a_date_time
		end


feature -- State

	name: STRING is "If-Modified-Since"

	date_time: STDC_TIME
			-- Value of field.

	value: STRING is
		do
			Result := date_time.rfc_date_string
		end


invariant

	date_time_not_void: date_time /= Void
	time_zone_known: date_time.is_time_zone_known

end
