indexing

	description: "Converts arrays to pointers."
	thanks: "The mico/E team for the idea."

	date: "$Date: 2003/11/29 $"
	revision: "$Revision: #2 $"


class

	EPX_ARRAY_HELPER


inherit

	ABSTRACT_ARRAY_HELPER
		undefine
			unfreeze_all
		end

	EPX_ISE_GC_HELPER
		rename
			unfreeze_objects as unfreeze_all
		end


feature -- ISE specific conversions

	integer_array_to_pointer (a: ARRAY [INTEGER]): POINTER is
		local
			c_any: ANY
		do
			c_any := a.to_c
			if c_any /= Void then
				-- When the garbage collection is disabled, $c_any just works.
				-- And because the string we pass to the C function
				-- must be short-lived, enabling the gc after the call
				-- is made, should not pose any problems.
				if memory.collecting then
					Result := eif_freeze (c_any)
					store_freezed_object (Result)
				else
					Result := $c_any
				end
			end
		end

	pointer_array_to_pointer (a: ARRAY [POINTER]): POINTER is
			-- Convert to void **.
		local
			c_any: ANY
-- 			pr: POINTER_REF
		do
			c_any := a.to_c
-- 			create pr
-- 			pr.set_item ($c_any)
-- 			Result := pr.item
			-- I supposed this would work, analogous to
			-- string_to_pointer. It doesn't. I get weird segmentation
			-- violations when I do this.
			if c_any /= Void then
				-- When the garbage collection is disabled, $c_any just works.
				-- And because the string we pass to the C function
				-- must be short-lived, enabling the gc after the call
				-- is made, should not pose any problems.
				if memory.collecting then
					Result := eif_freeze (c_any)
					store_freezed_object (Result)
				else
					Result := $c_any
				end
			end
		end


end
